"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createParameterInjectionDecorator = exports.createMethodDecorator = void 0;
function createMethodDecorator(metakey, metadata) {
    return (target, key, descriptor) => {
        Reflect.defineMetadata(metakey, metadata, descriptor.value);
        return descriptor;
    };
}
exports.createMethodDecorator = createMethodDecorator;
function createParameterInjectionDecorator(metakey, metadata) {
    return (target, propertyKey, parameterIndex) => {
        var _a;
        const injections = (_a = Reflect.getOwnMetadata(metakey, target, propertyKey)) !== null && _a !== void 0 ? _a : {};
        const paramDecorations = Object.assign(Object.assign({}, injections), { [parameterIndex]: metadata });
        Reflect.defineMetadata(metakey, paramDecorations, target, propertyKey);
    };
}
exports.createParameterInjectionDecorator = createParameterInjectionDecorator;
